//
// Make prediction image by block copying based on motion vectors
//
#include "usage.h"
#include "picture.h"
#include <fstream>
#include <stdlib.h>
#include <math.h>

int main(int argc, char *argv[])
	{
	usage("blockpred prevframe motionvecs predpic");
	colour_picture prev(argv[1]);
	prev.dc_pad();
	int ymax = prev.nrows();
	int xmax = prev.ncols();
	colour_picture out(ymax, xmax, 64, prev.ismonochrome());
	ifstream vecs(argv[2]);	// List of motion vectors
	int blocksize, maxdisplacement;
	vecs >> blocksize >> maxdisplacement;
	// First line has blocksize and maximum possible displacement
	irange xblock(0,1,blocksize-1);
	irange yblock(0,1,blocksize-1);
	while(!vecs.eof()) {
		int i, j, icomp, jcomp;
		vecs >> i >> j >> icomp >> jcomp;
		i -= blocksize/2;
		j -= blocksize/2;
		// Next line does a block copy to appropriate position
		out[yblock+i][xblock+j] = 
		  prev[yblock+i+icomp][yblock+j+jcomp];
	    }
	out.write(argv[3]);
	return 1;
	}
