//
// downsample inpic outpic mode odd_or_even
// reads inpic and removes every other sample either vertically (mode = 'v'),
// horizontally (mode = 'h') or both (mode = 'b'), then writes result to
// outpic. If odd_or_even is 'o', removes odd numbered samples; if odd_or_even
// is 'e', removes even numbered samples.
//
// John Robinson. February 1997.
//
#include "picture.h"

int main(int argc, char *argv[])
	{
	if (argc != 5) {
		cerr << "Usage: downsample inpic outpic mode odd_or_even\n";
		cerr << "mode is single char: 'h' for horiz, 'v' for vert, ";
		cerr << "'b' for both.\nodd_or_even is 'o' or 'e'.\n";
		return -1;
		}
	colour_picture in(argv[1]);
	int xfirst = 0;
	int xsecond = 1;
	int xlast = in.ncols()-1;
	int yfirst = 0;
	int ysecond = 1;
	int ylast = in.nrows()-1;
	if ((argv[3][0] == 'h')||(argv[3][0] == 'b'))
		{
		if (argv[4][0] == 'e')	// 0,2,ncols-2
			{
			xsecond = 2;
			xlast--;
			}
		else			// 1,3,ncols-1
			{
			xfirst = 1;
			xsecond = 3;
			}
		}
	if ((argv[3][0] == 'v')||(argv[3][0] == 'b'))
		{
		if (argv[4][0] == 'e')	// 0,2,ncols-2
			{
			ysecond = 2;
			ylast--;
			}
		else			// 1,3,ncols-1
			{
			yfirst = 1;
			ysecond = 3;
			}
		}
	irange xrange(xfirst, xsecond, xlast);
	irange yrange(yfirst, ysecond, ylast);
	colour_picture out(yrange.length(),xrange.length(),64,in.ismonochrome());
	out = in[yrange][xrange];
	out.write(argv[2]);
	return 1;
	}
