//
// Calculation of psnr between two images. CLIP version that replaces the
// old psnr.cpp where it is desired to compare with .bmp images too.
// John Robinson, 1995, 2005
//
#include "picture.h"

int main(int argc, char *argv[]) {
	if (argc != 3) {
		cerr << "Usage: psnr inpic outpic\n";
		return -1;
		}
	colour_picture_of_<float> one(argv[1]);
	colour_picture_of_<float> two(argv[2]);
	if ((one.nrows() != two.nrows()) || (one.ncols() != two.ncols())) {
		cerr << "Images are not the same size\n";
		return 0;
		}
	one -= two;
	one *= one;
	float mse = one.total()/(one.nrows()*one.ncols());
	if (!one.ismonochrome())
		mse /= 3.0;
	if (mse == 0)
		cout << " Infinity\n";
	else {
		double psnr;
		psnr = 255.0*255.0/mse;
		psnr = 10*log10(psnr);
		cout << ' ' << psnr << '\n';
		}
	return 1;
	}
