//
// Decompresses a picture from a code file generated by 2into1. Pairs of pels
// are packed into bytes. Merely have to unpack these and write back into a
// picture.
//
// John Robinson, 1997
//
#include "picture.h"
#include "usage.h"
#include <fstream>
int main(int argc, char *argv[])
	{
	usage("un2into1 codefile outpic");
	ifstream code(argv[1]);
	if (!code) {
		cerr << "Can't open " << argv[1] << endl;
		return -1;
		}
	int even = 1;	//Alternates between even and odd
	int nrows, ncols;
	unsigned char inbyte;
	code >> nrows >> ncols;
	inbyte = code.get();
	// code.get(inbyte);	// To absorb the newline
	picture_of_int out(nrows, ncols);
	for (int i=0; i < nrows; i++)
	for (int j=0; j < ncols; j++)
		{
		if (even) {
			// code.get(inbyte);
			inbyte = code.get();
			even = 0;
			out[i][j] = inbyte>>4;
			}
		else
			{
			even = 1;
			out[i][j] = inbyte & 0xf;
			}
		}
	code.close();
	out.write(argv[2]);
	return 1;
	}

