//
// Runlength decoding.
// Accepts a file generated by rlc, and recovers the original picture.
//
// John Robinson. January 1997.
//
#include <fstream>
#include "usage.h"
#include "picture.h"
int main(int argc, char *argv[])
	{
	usage("unrlc codefile outpic");
	ifstream in(argv[1]);
	if (!in) {
		cerr << "Can't open " << argv[1] << endl;
		return -1;
		}
	int rows, cols;
	unsigned char c;
	in >> rows >> cols;
	// Header of the rlc file gives the picture dimensions.
	// in.get(c);	// Absorb the newline at the end of the header
	c = in.get();
	picture_of_int out(rows,cols);
	int prev = 255;	// Assume starts black, so initialize at white
			// with 0 left to count
	int cnt = 0;
	for (int i = 0; i < rows; i++)
	for (int j = 0; j < cols; j++)
	// Scan picture in raster order
		{
		while (cnt == 0) { // Use while rather than if so can
				   // handle runlengths of zero.
			// in.get(c);
			c = in.get();
			cnt = c;
			if (prev) prev = 0;
			else prev = 255;
			}
		out[i][j] = prev;
		cnt--;
		}
	in.close();
	out.write(argv[2]);
	return 1;
	}

