// Program to rotate a picture about its centre
#include "picture.h"
#include "usage.h"
#include "math.h"
#include "stdlib.h"
int main(int argc, char *argv[]) {
	usage("rotate inpic outpic angle[degs]");
	colour_picture temp(argv[1]);
	int nr = temp.nrows();
	int nc = temp.ncols();
	int border = nr;
	if (nc > nr) border = nc;		// Very large border
	colour_picture in(argv[1],border);
	in.dc_pad();
	colour_picture out(in);
	double theta = atof(argv[3]);
	theta *= 3.141592/180;			// Convert to radians
	double sint = sin(theta);
	double cost = cos(theta);
	for (int i = 0; i < nr; i++)
	for (int j = 0; j < nc; j++) {
		int xout = j - nc/2;
		int yout = i - nr/2;
		double xin = xout*cost + yout*sint + nc/2;
		double yin = -xout*sint + yout*cost + nr/2;
		out.map(j, i, in, xin, yin, 0);
		}
	out.write(argv[2]);
	return 0;
	}
